﻿local allshow = {
[10326] = true, 	--超度邪恶
[123586] = true,	--翔龙减速
[31589] = true,		--法师减速
[391104] = true,	--法师群体减速
[360806] = true,	--龙人梦游
[278467] = true,	--自由镇坏酒
[388523] = true,	--奈萨鲁斯2号易伤
[377014] = true,	--奈萨鲁斯尾王易伤
}


function BuffFramePoint(self)
	if self:IsForbidden() then return end
	
	--因为光环那里是hook,暴雪提前self.auras[auraInstanceID]=nil,所以要在这里判断光环还在不在
	if self:GetParent().useHpColor then
		if not self:HasActiveBuff(self:GetParent().useHpColor.spellId) then
			self:GetParent().useHpColor = nil
		end
	end
	if self:GetParent().useNameColor then
		if not self:HasActiveBuff(self:GetParent().useNameColor.spellId) then
			self:GetParent().useNameColor = nil
		end
	end
	if self:GetParent().useBorderColor then
		if not self:HasActiveBuff(self:GetParent().useBorderColor.spellId) then
			self:GetParent().useBorderColor = nil
		end
	end
	
	--执行原来的内容
	--光环高度=高度*是否方形
	local aurahigth = PlateColorDB.auraSquare and PlateColorDB.auraScale or PlateColorDB.auraScale * 0.8
	
	--名字高度
	local namehight = PlateColorDB.enemyNameScale*1.43 or 0
	
	--BuffFrame默认高15,因为自定义了光环大小,要计算比原来偏移多少
	local auraY = PlateColorDB.auraSquare and PlateColorDB.auraScale-15 or PlateColorDB.auraScale*.8-15
	
	--是否显示名字
	local nameshown = self:GetParent().nametext and self:GetParent().nametext:IsShown()
	
	--设置buffframe位置
	local isTarget = self:GetParent().unit and UnitIsUnit(self:GetParent().unit, "target");
	local targetYOffset = self:GetBaseYOffset() + (isTarget and self:GetTargetYOffset() or 0.0);
	if (self:GetParent().unit and nameshown) then
		self:SetPoint("BOTTOMLEFT", self:GetParent().healthBar, "TOPLEFT", 0, auraY + namehight + targetYOffset);
	else
		self:SetPoint("BOTTOMLEFT", self:GetParent().healthBar, "TOPLEFT", 0, auraY + targetYOffset);
	end
	--个人资源光环缩放
	if self:GetParent().unit and UnitIsUnit(self:GetParent().unit,"player") then
		self:SetScale(PlateColorDB.selfAuraScale)
		self:SetShown(PlateColorDB.selfHpAura)
	else
		self:SetScale(1)
	end
end


local function BuffFrameYOffset(self)
	if self:IsForbidden() then return end
	
	--设置我们的偏移
	if self.driverFrame:IsUsingLargerNamePlateStyle() then
		self.UnitFrame.BuffFrame:SetBaseYOffset(3 + PlateColorDB.auraOffsetY);
	else
		self.UnitFrame.BuffFrame:SetBaseYOffset(3 + PlateColorDB.auraOffsetY);
	end

	local targetMode = GetCVarBool("nameplateResourceOnTarget");
	if targetMode then
		self.UnitFrame.BuffFrame:SetTargetYOffset(18+PlateColorDB.auraOffsetY);
	else
		self.UnitFrame.BuffFrame:SetTargetYOffset(PlateColorDB.auraOffsetY);
	end
end

local function MyShowDebuff(self,aura,forceAll)
	local mydot = (aura.sourceUnit == "player" or aura.sourceUnit == "pet" or aura.sourceUnit == "vehicle")
	local showself = aura.nameplateShowPersonal and mydot
	local mytabledot = mydot and PlateColorDB["Auras"][aura.spellId]
	local showall = aura.nameplateShowAll--self:ShouldShowBuff(aura, forceAll)
	
	if  (showself or mytabledot or allshow[aura.spellId] or showall) then
		return true
	end
end
local function ParseAllAuras(self,forceAll)
	if self.auras == nil then
		self.auras = TableUtil.CreatePriorityTable(AuraUtil.DefaultAuraCompare, TableUtil.Constants.AssociativePriorityTable);
	else
		self.auras:Clear();
	end

	local function HandleAura(aura)
		if MyShowDebuff(self,aura,forceAll) then
			self.auras[aura.auraInstanceID] = aura;
		end
		return false;
	end

	local batchCount = nil;
	local usePackedAura = true;
	AuraUtil.ForEachAura(self.unit, self.filter, batchCount, HandleAura, usePackedAura);
end

local function PCUpdateBuffs(self,unit, unitAuraUpdateInfo, auraSettings)
if self:IsForbidden() then return end
	local filters = {};
	if auraSettings.helpful then
		table.insert(filters, AuraUtil.AuraFilters.Helpful);
	end
	if auraSettings.harmful then
		table.insert(filters, AuraUtil.AuraFilters.Harmful);
	end
	if auraSettings.raid then
		table.insert(filters, AuraUtil.AuraFilters.Raid);
	end
	if auraSettings.includeNameplateOnly then
		table.insert(filters, AuraUtil.AuraFilters.IncludeNameplateOnly);
	end
	local filterString = AuraUtil.CreateFilterString(unpack(filters));

	local previousFilter = self.filter;
	local previousUnit = self.unit;
	self.unit = unit;
	self.filter = filterString;

	local aurasChanged = false;
	if unitAuraUpdateInfo == nil or unitAuraUpdateInfo.isFullUpdate or unit ~= previousUnit or self.auras == nil or filterString ~= previousFilter then
		ParseAllAuras(self,auraSettings.showAll);
		aurasChanged = true;
	else
		if unitAuraUpdateInfo.addedAuras ~= nil then
			for _, aura in ipairs(unitAuraUpdateInfo.addedAuras) do
				if MyShowDebuff(self,aura,auraSettings.showAll) and not C_UnitAuras.IsAuraFilteredOutByInstanceID(unit, aura.auraInstanceID, filterString) then
					self.auras[aura.auraInstanceID] = aura;
					aurasChanged = true;
				end
			end
		end

		if unitAuraUpdateInfo.updatedAuraInstanceIDs ~= nil then
			for _, auraInstanceID in ipairs(unitAuraUpdateInfo.updatedAuraInstanceIDs) do
				if self.auras[auraInstanceID] ~= nil then
					local newAura = C_UnitAuras.GetAuraDataByAuraInstanceID(self.unit, auraInstanceID);
					self.auras[auraInstanceID] = newAura;
					aurasChanged = true;
				end
			end
		end

		if unitAuraUpdateInfo.removedAuraInstanceIDs ~= nil then
			for _, auraInstanceID in ipairs(unitAuraUpdateInfo.removedAuraInstanceIDs) do
				if self.auras[auraInstanceID] ~= nil then
					self.auras[auraInstanceID] = nil;
				end
			end
			aurasChanged = true;
		end
	end
	
	self:UpdateAnchor();

	if not aurasChanged then
		return;
	end

	self.buffPool:ReleaseAll();

	if auraSettings.hideAll or not self.isActive then
		return;
	end
	
	local buffIndex = 1;
	self.auras:Iterate(function(auraInstanceID, aura)
		
		local buff = self.buffPool:Acquire();
		
		if type(PlateColorDB["Auras"][aura.spellId]) == "table" then
			if PlateColorDB["Auras"][aura.spellId]["usehp"] then
				self:GetParent().useHpColor = aura
			end
			if PlateColorDB["Auras"][aura.spellId]["usename"] then
				self:GetParent().useNameColor = aura
			end
			if PlateColorDB["Auras"][aura.spellId]["useborder"] then
				self:GetParent().useBorderColor = aura
			end
		end
		if PlateColorDB.hideAura then self:Hide() return end
		if type(PlateColorDB["Auras"][aura.spellId]) == "table" and PlateColorDB["Auras"][aura.spellId]["usehide"] then return end
		buff.auraInstanceID = auraInstanceID;
		buff.isBuff = aura.isHelpful;
		buff.layoutIndex = buffIndex;
		buff.spellID = aura.spellId;
		
		local gaodu = PlateColorDB.auraSquare and PlateColorDB.auraScale or PlateColorDB.auraScale * 0.8
		buff.Icon:GetParent():SetSize(PlateColorDB.auraScale,gaodu)
		buff.Icon:SetSize(PlateColorDB.auraScale,gaodu)
		
		buff.Icon:SetTexCoord(0,1,0,1)
		buff.Cooldown:SetHideCountdownNumbers(not PlateColorDB.auraCooldownText)
		local textsize = PlateColorDB.auraScale * 0.65
		buff.Cooldown:GetRegions():SetFont(STANDARD_TEXT_FONT, textsize, "OUTLINE")
        buff:EnableMouse(PlateColorDB.auraToolTip)
		
		buff.Icon:SetTexture(aura.icon);
		if (aura.applications > 1) then
			buff.CountFrame.Count:SetText(aura.applications);
			buff.CountFrame.Count:Show();
		else
			buff.CountFrame.Count:Hide();
		end
		CooldownFrame_Set(buff.Cooldown, aura.expirationTime - aura.duration, aura.duration, aura.duration > 0, true);
		

		buff:Show();
		buffIndex = buffIndex + 1;
		return buffIndex >= BUFF_MAX_DISPLAY;

	end);

	--Add Cooldowns 
	if(buffIndex < BUFF_MAX_DISPLAY and UnitIsUnit(self:GetParent().unit, "player")) then 
		local nameplateSpells = C_SpellBook.GetTrackedNameplateCooldownSpells(); 
		for _, spellID in ipairs(nameplateSpells) do 
		
			if (not self:HasActiveBuff(spellID) and buffIndex < BUFF_MAX_DISPLAY) then
				local locStart, locDuration = GetSpellLossOfControlCooldown(spellID);
				local start, duration, enable, modRate = GetSpellCooldown(spellID);
				if (locDuration ~= 0 or duration ~= 0) then 
					local spellInfo = C_SpellBook.GetSpellInfo(spellID);
					if(spellInfo) then 
						local buff = self.buffPool:Acquire();
						buff.isBuff = true;
						buff.layoutIndex = buffIndex;
						buff.spellID = spellID; 
						buff.auraInstanceID = nil;
						buff.Icon:SetTexture(spellInfo.iconID); 

						local charges, maxCharges, chargeStart, chargeDuration, chargeModRate = GetSpellCharges(spellID);
						buff.Cooldown:SetEdgeTexture("Interface\\Cooldown\\edge");
						buff.Cooldown:SetSwipeColor(0, 0, 0);
						CooldownFrame_Set(buff.Cooldown, start, duration, enable, false, modRate);

						if (maxCharges and maxCharges > 1) then
							buff.CountFrame.Count:SetText(charges);
							buff.CountFrame.Count:Show();
						else
							buff.CountFrame.Count:Hide();
						end

						buff:Show();
						buffIndex = buffIndex + 1; 
					end
				end
			end
		end 
	end	

	self:Layout();
end

hooksecurefunc(NamePlateBaseMixin,"ApplyOffsets", BuffFrameYOffset)
hooksecurefunc(NameplateBuffContainerMixin, "UpdateAnchor", BuffFramePoint)
hooksecurefunc(NameplateBuffContainerMixin, "UpdateBuffs", PCUpdateBuffs)